package no.uio.inf5750.assignment3;

import java.util.LinkedList;

import no.uio.inf5750.assignment3.accounts.Accounts;
import no.uio.inf5750.assignment3.dashboard.DashboardActivityNew;
import no.uio.inf5750.assignment3.util.ConnectionManager;
import no.uio.inf5750.assignment3.util.UpdateDaemon;
import no.uio.inf5750.assignment3.util.Util;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;
import android.view.WindowManager;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

public class MainActivity extends Activity {
	
	private Context mContext;
	private Activity mActivity;
	private LinkedList<String[]> mAccounts;
	private final static String PREFS_NAME = "PREFERENCES";
	//private EditText mUsername, mPassword, mServer;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.login);
		
		mContext = this;
		mActivity = this;

	}
	
	@Override
	public void onResume()
	{
		super.onResume();
		checkAccounts();
		
	}
	
	public void showAccounts()
	{
		Intent intent = new Intent(mContext, Accounts.class);
		startActivity(intent);
	}
		
	/**
	 * Retrieves all stored user accounts (if any), display them in the spinner
	 */
	public void checkAccounts()
	{

        mAccounts = Util.getAccounts(mContext);
        String[] accountNames = new String[mAccounts.size()];
        if(mAccounts.isEmpty())
        {
        	launchNoAccountsDialog();
        }
        else
        {	

        	//Just launch the dashboard if there are existing accounts!
        	launchDashboard();
        	return;
        }	
	}
	
	private void launchNoAccountsDialog() {
		
		AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(
				this);

		final Activity activity = this;
		// set title
		alertDialogBuilder.setTitle("Welcome!");

		// set dialog message
		alertDialogBuilder.setMessage("You have no accounts set up. Please setup an account now.");
		alertDialogBuilder.setCancelable(false);
		alertDialogBuilder.setPositiveButton("Accounts",
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						// if this button is clicked, close
						// current activity
						dialog.cancel();
						Intent intent = new Intent(activity, Accounts.class);
						activity.startActivity(intent);
					}
				});
		alertDialogBuilder.setNegativeButton("Exit DHIS2",
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						// if this button is clicked, just close
						// the dialog box and do nothing
						dialog.cancel();
						activity.finish();
					}
				});

		// create alert dialog
		AlertDialog alertDialog = alertDialogBuilder.create();

		// show it
		alertDialog.show();
		
	}

	class LoginOnClickListener implements OnClickListener {

		public void onClick(View arg0) {
			
			launchDashboard();
		}

	}
	
	public void launchDashboard()
	{
		storeLoginData();
		
		Intent intent = new Intent(mContext, DashboardActivityNew.class);
		startActivity(intent);
		mActivity.finish();
	}
	
	public void storeLoginData()
	{
		int currentSelection = 0;//mSpinner.getSelectedItemPosition();
		ConnectionManager.getConnectionManager().setAccount(currentSelection, mContext);
	}
}
