package no.uio.inf5750.assignment3.accounts;

import java.util.LinkedList;

import no.uio.inf5750.assignment3.R;
import no.uio.inf5750.assignment3.util.UpdateDaemon;
import no.uio.inf5750.assignment3.util.Util;
import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;

public class Accounts extends Activity{
	
	private Context mContext;
	private EditText mEditProfileName, mEditServer, mEditUsername, mEditPassword;
	private LinkedList<String[]> mProfiles;
	private ListView mListViewProfiles;
	private int mCurrentSelectedProfile = -1;
	private Button mButtonCreate, mButtonDelete;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.accounts);
		mContext = this;
		mProfiles = Util.getAccounts(mContext);
		setGraphicalElements();

	}
	
	public void setGraphicalElements()
	{
		mEditProfileName = (EditText) findViewById(R.id.accounts_accountname);
		mEditServer = (EditText) findViewById(R.id.accounts_serverurl);
		mEditUsername = (EditText) findViewById(R.id.accounts_username);
		mEditPassword = (EditText) findViewById(R.id.accounts_password);
		mListViewProfiles = (ListView) findViewById(R.id.accounts_accounts_list);
		
		mListViewProfiles.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2,
					long arg3) {
				// TODO Auto-generated method stub
				
				setCurrentProfile(arg2);
				
			}
		});
		
		setListView();
		
		mButtonCreate = (Button) findViewById(R.id.accounts_createbutton);
		mButtonDelete = (Button) findViewById(R.id.accounts_deletebutton);
		
		mButtonCreate.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View arg0) {
				
				createAccount();
				
			}
		});
		
		mButtonDelete.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				deleteAccount();
			}
		});
	}
	
	public void deleteAccount()
	{
		if(mCurrentSelectedProfile == -1)
			return;
		Util.removeAccount(mContext, mCurrentSelectedProfile);
		mEditProfileName.setText("");
		mEditServer.setText("");
		mEditUsername.setText("");
		mEditPassword.setText("");
		setListView();
		mCurrentSelectedProfile = -1;
	}
	
	public void setListView()
	{
		String[] accountNames = Util.getAccountNames(mContext);
		mProfiles = Util.getAccounts(mContext);
		ArrayAdapter<String> adapter = new ArrayAdapter<String>(mContext, R.layout.accounts_list_item, accountNames);
		mListViewProfiles.setAdapter(adapter);
	}

	public void setCurrentProfile(int position) {
		// TODO Auto-generated method stub
		String readableName = mProfiles.get(position)[0];
		String server = mProfiles.get(position)[1];
		String username = mProfiles.get(position)[2];
		String password = mProfiles.get(position)[3];
		
		mEditServer.setText(server);
		mEditProfileName.setText(readableName);
		mEditUsername.setText(username);
		mEditPassword.setText(password);
		
		mCurrentSelectedProfile = position;
		
	}
	
	public void createAccount()
	{
		String accountName = mEditProfileName.getText().toString();
		String server = mEditServer.getText().toString();
		String username = mEditUsername.getText().toString();
		String password = mEditPassword.getText().toString();
		
		String[] account = new String[]{accountName, server, username, password};
		Util.storeAccount(mContext, account);
		
		setListView();
	}

}
