package no.uio.inf5750.assignment3.messaging;

import no.uio.inf5750.assignment3.R;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.Set;

import no.uio.inf5750.assignment3.util.ConnectionManager;
import no.uio.inf5750.assignment3.util.UpdateDaemon;
import no.uio.inf5750.assignment3.util.User;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.SearchManager;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.view.WindowManager.LayoutParams;
import android.view.inputmethod.EditorInfo;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;
import android.widget.Toast;

public class WriteMessageActivity extends Activity {
	
	// Not sure if we'll need this
	private String mMessage = "";
	private Button mButtonSend;
	private EditText mEditTextMessage;
	private EditText mEditTextSubject;
	private Button mButtonSearch;
	private Button mButtonBack;
	private EditText mEditTextSearch;
	private User mRecipient;
	private ListView mListViewRecipients;
	private LinkedList<User> mRecipients;
	private LinkedList<User> mUserList;
	private AlertDialog mAlertDialog;
	private Context mContext;

	/** 
	 * Called when the activity is first created. 
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.writemessage);

		// Add the buttons and their actions
		mContext = this;
		mRecipients = new LinkedList<User>();
		setButtons();
		mUserList = new LinkedList<User>();
		//UpdateDaemon.getDaemon().updateUsers();
	}

	/**
	 * Initialize button listener for message activity
	 */
	public void setButtons() {
		
		mButtonSend = (Button) findViewById(R.id.writemessage_send);
		mEditTextMessage = (EditText) findViewById(R.id.writemessage_message_field);
		mEditTextSubject = (EditText) findViewById(R.id.writemessage_subject);
		mEditTextSearch = (EditText) findViewById(R.id.writemessage_search_field);
		mButtonSearch = (Button) findViewById(R.id.writemessage_search_button);
		mButtonBack = (Button) findViewById(R.id.writemessage_back);
		mListViewRecipients = (ListView) findViewById(R.id.writemessage_recipients_list);
		
		setListView();
		setListViewOnClickListener();
		
		mButtonBack.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				confirmClose();
			}
		});
		
		mEditTextSearch.setOnEditorActionListener(new OnEditorActionListener() {
		   
			@Override
			public boolean onEditorAction(TextView arg0, int arg1, KeyEvent arg2) {
				if (arg1 == EditorInfo.IME_ACTION_NEXT) {
		            mButtonSearch.performClick();
		            return true;
		        }
		        return false;
			}
		});
		
		mButtonSearch.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				searchUsers();
			}
		});
		
		mButtonSend.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				sendMessage();
			}
		});
		
	}
	
	public void searchUsers()
	{
		System.out.println("searchUsers");
		String searchQuery = mEditTextSearch.getText().toString();
		searchQuery = searchQuery.trim();
		LinkedList<User> searchHits;
		
		searchHits = UpdateDaemon.getDaemon().searchUsers(searchQuery);
		
		if(searchHits.size()>0)
		{
			showSelectorDialog(searchHits);
		}
		else
		{
			Toast.makeText(mContext, "The search returned no matches", Toast.LENGTH_LONG).show();
		}
		
	}
	
	public void setListView()
	{
		String[] values = new String[mRecipients.size()];
		for(int i = 0; i<values.length; i++)
		{
			values[i] = mRecipients.get(i).mName;
		}
		
		if(mRecipients.size()<1)
		{
			values = new String[]{"Add recipient to message"};
			mListViewRecipients.setOnItemClickListener(new OnItemClickListener() {

				@Override
				public void onItemClick(AdapterView<?> arg0, View arg1,
						int arg2, long arg3) {
					//Do nothing
					
				}
			});
		}
		else
		{
			setListViewOnClickListener();
		}
		System.out.println("recipients size: "+mRecipients.size());
		ArrayAdapter<String> arrayAdapter = new ArrayAdapter<String>(this, R.layout.list_item,	values);
		mListViewRecipients.setAdapter(arrayAdapter);
		
	}
	
	public void setListViewOnClickListener()
	{
		mListViewRecipients.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2,
					long arg3) {
				// TODO Auto-generated method stub
				//mUserList.add(mRecipients.get(arg2));
				if(mRecipients.size()>arg2)
					mRecipients.remove(arg2);
				
				setListView();
				
			}
			
		});
	}
	
	public void addRecipient(User user)
	{
		
		
		String id = user.mId;
		//Firstly check if this user is already added
		boolean contains = false;
		for(int i = 0; i<mRecipients.size(); i++)
		{
			if(id.equals(mRecipients.get(i).mId))
			{
				contains = true;
				break;
			}
		}
		
		if(!contains)
			mRecipients.add(user);
		
	}
	
	public void showSelectorDialog(final LinkedList<User> users)
	{
		AlertDialog.Builder adb = new AlertDialog.Builder(this);
		String[] items = new String[users.size()];
		for(int i = 0; i<users.size(); i++)
		{
			items[i] = users.get(i).mName;
		}
		int checkedItem = 0;
		
		android.content.DialogInterface.OnClickListener listener;
		listener = new android.content.DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				addRecipient(users.get(which));
				
				//mUserList.remove(users.get(which));
				setListView();
				mAlertDialog.dismiss();
				mEditTextSearch.setText("");
				mEditTextSubject.requestFocus();
			}
		};
		
		adb.setSingleChoiceItems(items, checkedItem, listener);
		adb.setNegativeButton("Cancel", null);
		adb.setTitle("Search results:");
		mAlertDialog = adb.show();
		
		
	}
	
	/**
	 * Takes the text input in reply text field and submits it to the server as a part of the conversation.
	 */
	public void sendMessage()
	{
		String subject = mEditTextSubject.getText().toString();
		String text = mEditTextMessage.getText().toString();
		ConnectionManager.getConnectionManager().sendMessage(mRecipients, text, subject);
		//ConnectionManager.getConnectionManager().replyMessage(mIndex, text);
		//showMessage();//Reload and show the messages of this conversation.
		System.out.println("sendmessage");
		Toast.makeText(this, "Sent message", Toast.LENGTH_SHORT).show();
		this.finish();
		
	}
	
	@Override
    public boolean onKeyDown (int keyCode, KeyEvent event)
    {
        switch(keyCode)
        {   
          
	        case KeyEvent.KEYCODE_BACK:
	        {
	            confirmClose();
	            return true;     
	        }
	          
	        case KeyEvent.KEYCODE_MENU:
	        {
	            return true;
	        }
          
        }
          
        return super.onKeyDown(keyCode, event);
    } 
	
	private void confirmClose() {
		AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);

		// set title
		alertDialogBuilder.setTitle("Discard message?");

		final Activity activity = this;
		// set dialog message
		alertDialogBuilder.setMessage("Are you sure you want to discard the message?");
		alertDialogBuilder.setCancelable(true);
		alertDialogBuilder.setPositiveButton("Discard",
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						// if this button is clicked, close
						// current activity

						activity.finish();
						dialog.cancel();
						
						
					}
				});
		alertDialogBuilder.setNegativeButton("Cancel",
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						// if this button is clicked, just close
						// the dialog box and do nothing
						dialog.cancel();
					}
				});

		// create alert dialog
		AlertDialog alertDialog = alertDialogBuilder.create();

		// show it
		alertDialog.show();
	}
	
	

}
