package no.uio.inf5750.assignment3.util;

import no.uio.inf5750.assignment3.accounts.Accounts;
import no.uio.inf5750.assignment3.dashboard.DashboardActivityNew;
import no.uio.inf5750.assignment3.interpretation.InterpretationActivityNew;
import no.uio.inf5750.assignment3.messaging.MessagingActivity;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.view.KeyEvent;

public class BaseActivity extends Activity {
	
	private Activity mActivity = this;

	@Override
	public void onResume()
	{
		super.onResume();
		Util.updateSlidingDrawer(this);
	}
	
	@Override
    public boolean onKeyDown (int keyCode, KeyEvent event)
    {
        switch(keyCode)
        {   
          
	        case KeyEvent.KEYCODE_BACK:
	        {
	            confirmClose();
	            return true;     
	        }
	          
	        case KeyEvent.KEYCODE_MENU:
	        {
	            return true;
	        }
          
        }
          
        return super.onKeyDown(keyCode, event);
    } 
	
	private void confirmClose() {
		AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);

		// set title
		alertDialogBuilder.setTitle("Confirm exit");

		// set dialog message
		alertDialogBuilder.setMessage("Are you sure you want to close DHIS2?");
		alertDialogBuilder.setCancelable(true);
		alertDialogBuilder.setPositiveButton("Close",
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						// if this button is clicked, close
						// current activity

						mActivity.finish();
						dialog.cancel();
						
						
					}
				});
		alertDialogBuilder.setNegativeButton("Cancel",
				new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						// if this button is clicked, just close
						// the dialog box and do nothing
						dialog.cancel();
					}
				});

		// create alert dialog
		AlertDialog alertDialog = alertDialogBuilder.create();

		// show it
		alertDialog.show();
	}

	protected void showError(String error)
	{
		Util.displayErrorDialog(this, error);
	}

	protected void launchActivity(int position) {
		
		//Set the current selected module globally
		
		switch (position) {
		case 0: {

			Globals.getGlobals().setCurrentModule(position);
			Intent intent = new Intent(this, DashboardActivityNew.class);
			startActivity(intent);
			this.finish();
			break;
		}

		case 1: {
			Globals.getGlobals().setCurrentModule(position);
			Intent intent = new Intent(this, MessagingActivity.class);
			startActivity(intent);
			this.finish();
			break;
		}

		case 2: {
			Globals.getGlobals().setCurrentModule(position);
			Intent intent = new Intent(this, InterpretationActivityNew.class);
			startActivity(intent);
			this.finish();
			break;
		}
		
		case 3: {
			Intent intent = new Intent(this, Accounts.class);
			startActivity(intent);
			break;
		}

		default: {
			Intent intent = new Intent(this, DashboardActivityNew.class);
			startActivity(intent);
		}
		}

	}

	public void switchAccount(int position) {
		System.out.println("baseSwitchAccount");
	}

}
