package no.uio.inf5750.assignment3.util;

import java.util.LinkedList;

/**
 * Class used for storing interpretation-data
 * @author Jan Anders Bremer
 *
 */
public class Interpretation extends ConversationBase {
	public LinkedList<InterpretationInfoNode> mInfo = new LinkedList<InterpretationInfoNode>();
	public String mCreated = "";
	public String mType = "";
	public String mResourceId = "";
	
	public String getInterpretationDataUrl()
	{
		//mType is typically map | chart | reportTable | dataSetReport - but for getting a link to the resource, they are usually located in /maps/ | /charts/ ... 
		//Hence the "s/"
		return ConnectionManager.getConnectionManager().getSite() + "/api/" + mType + "s/" + mResourceId + "/data";
	}
	
	/**
	 * @return URL of the interpretation
	 */
	public String getInterpretationUrl() {
		return getInterpretationUrl(mId);
	}
	
	/**
	 * @param id of the interpretation
	 * @return URL of the interpretation
	 */
	public static String getInterpretationUrl(String id) {
		return getInterpretationBaseUrl() + id + getInterpretationPostfixUrl();
	}
	
	/**
	 * @return URL prefix
	 */
	private static String getInterpretationBaseUrl() {
		return ConnectionManager.getConnectionManager().getSite() + "/api/interpretations/";
	}
	
	/**
	 * @return URL postfix
	 */
	private static String getInterpretationPostfixUrl() {
		return "/comment/";
	}
	
}
