package no.uio.inf5750.assignment3.util;

import java.util.LinkedList;

import no.uio.inf5750.assignment3.R;
import no.uio.inf5750.assignment3.util.ConnectionManager;
import no.uio.inf5750.assignment3.util.Dashboard;
import no.uio.inf5750.assignment3.util.DashboardItem;
import no.uio.inf5750.assignment3.util.Interpretation;
import no.uio.inf5750.assignment3.util.InterpretationInfoNode;
import android.app.Activity;
import android.content.Context;
import android.graphics.Interpolator.Result;
import android.graphics.drawable.Drawable;
import android.os.AsyncTask;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup.LayoutParams;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;

public class ModulesListArrayAdapter extends ArrayAdapter<String> {

	private Context mContext;
	private String[] mValues;

	public ModulesListArrayAdapter(Context context, int textViewResourceId,
			String[] objects) {
		super(context, textViewResourceId, objects);
		this.mValues = objects;
		this.mContext = context;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		LayoutInflater inflater = (LayoutInflater) mContext
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		View rowView = inflater.inflate(R.layout.modules_list_item, parent,false);
		TextView textView = (TextView) rowView.findViewById(R.id.modules_list_item_text);
		textView.setText(mValues[position]);
		
		int currentModule = Globals.getGlobals().getCurrentModule();
		if(position == currentModule)
		{//change the colour of this item
			rowView.setBackgroundColor(mContext.getResources().getColor(R.color.Cyan));
		}

		return rowView;
	}
	
	private class CustomAsyncTask extends AsyncTask<Object, Object, Drawable>
	{

		private Integer mmPosition;
		private ImageView mmImageView;
		private ProgressBar mmProgressBar;
		private DashboardItem mmDashboardItem;
		
		@Override
	    protected void onProgressUpdate(final Object... args) {
	        super.onProgressUpdate(args);
	    }
		
		@Override
		protected void onPreExecute() {
		}

		@Override 
		protected void onPostExecute(Drawable drawable) {
			if(drawable!=null)
			{
				mmImageView.setImageDrawable(drawable);
				mmImageView.setVisibility(View.VISIBLE);
				mmProgressBar.setVisibility(View.INVISIBLE);
			}
		}

		@Override
		protected Drawable doInBackground(Object... params) {
			// TODO Auto-generated method stub
			
			Object[] obj = params;
			System.out.println(obj.length);
			mmPosition = (Integer) params[0];
			mmImageView = (ImageView) params[1];
			mmProgressBar = (ProgressBar) params[2];
			mmDashboardItem = (DashboardItem) params[3];
			Drawable drawable = ConnectionManager.getConnectionManager().getImage(mmDashboardItem.mHref + "/data");
			return drawable;
		}
		
	}
	
	/**
	 * Shows the full size image of a dashboard item
	 */
	private void showFullSize()
	{
		
	}

	/**
	 * Shows the resource related to this dashboardItem
	 * @param position
	 * @param imageView
	 * @param errorTextView
	 * @param dashboardItem
	 */
	private void showChart(int position, ImageView imageView, ProgressBar progressBar,
			DashboardItem dashboardItem) {
		
		//Check what kind of resource this is
		String type = dashboardItem.mType;
		if(type.equals("chart"))
		{
			loadImageAsync(position, imageView, progressBar, dashboardItem);
		}
		else if(type.equals("patientTabularReports"))
		{
			
		}
		else if(type.equals("resources"))
		{
			
		}
		else if(type.equals("reports"))
		{
			
		}
		else if(type.equals("reportTable"))
		{
			makeReportTable();
		}
		else if(type.equals("map"))
		{
			loadImageAsync(position, imageView, progressBar, dashboardItem);
		}
		else if(type.equals("users"))
		{
			
		}
		else
		{
			
		}
		
	}
	
	public void loadImageAsync(int position, ImageView imageView, ProgressBar progressBar,
			DashboardItem dashboardItem)
	{
		CustomAsyncTask task = new CustomAsyncTask();
		Integer position_integer = position;
		Object[] obj = new Object[4];
		obj[0] = position_integer;
		obj[1] = imageView;
		obj[2] = progressBar;
		obj[3] = dashboardItem;
		task.execute(obj);
	}

	private void makeReportTable() {

		//Should here generate a report table using a tableLayout...
		
	}

}
